# Firefox

Browser profile configuration that can be set up directly within profile folders. Configuration is the same across devices and profiles, excepting a few settings adjusted manually.

## Extensions

- Adblock: [uBlock Origin](https://addons.mozilla.org/firefox/addon/ublock-origin/)
	- Remove cookie banners: <https://www.i-dont-care-about-cookies.eu/abp/>
	- Shorten URLs: <https://raw.githubusercontent.com/DandelionSprout/adfilt/master/LegitimateURLShortener.txt>
	- Custom: <https://letsblock.it/filters>
- Containers: [Multi-Account Containers](https://addons.mozilla.org/firefox/addon/multi-account-containers/) with [Temporary Containers](https://addons.mozilla.org/firefox/addon/temporary-containers/)
- Images: [Hover Zoom+](https://addons.mozilla.org/firefox/addon/hover-zoom-plus/)
- Navigation: [Vimium C](https://addons.mozilla.org/firefox/addon/vimium-c/)
- Passwords: [KeePassXC-Browser](https://addons.mozilla.org/firefox/addon/keepassxc-browser/)
- Paywalls: [Bypass Paywalls Clean](https://gitlab.com/magnolia1234/bypass-paywalls-firefox-clean)
- Redirects: [Skip Redirect](https://addons.mozilla.org/firefox/addon/skip-redirect/)
- YouTube: [Sponsorblock](https://addons.mozilla.org/firefox/addon/sponsorblock/) and [DeArrow](https://addons.mozilla.org/firefox/addon/dearrow/) (both a bit heavy)
- Reddit: [RES](https://addons.mozilla.org/firefox/addon/reddit-enhancement-suite/) (maybe replace)
- Trackers: [Torrent Control](https://addons.mozilla.org/en-CA/firefox/addon/torrent-control/) (replace)

## Profiles / Containers

- Ashton
	- *Default*
	- Finance
	- Social
- Work
	- *Default*
	- Personal

## Setup

```
git init
git config --local status.showUntrackedFiles no
git remote add origin $URL
git pull origin main
```

## Notes

- Control browser instance via devtools protocol (playwright)
- Development: devtools, modify headers, disable CSP
- Quick navigation (specific pages, custom search engines, previously closed page)
- Context menu (adjust for common operations)
- Shortcuts
	- Tabs: move, pop out, close, duplicate
	- Screenshots: full page, certain area, zoomed
	- Bookmark or note to revisit a tab
	- Search, navigate, etc. (most recent tab, regex search, spacial navigation)
- Export bookmarks and history
- Learn and adjust to vomnibar
- Bookmark tagging and export

## Reference

- Sample `user.js`
	- <https://github.com/arkenfox/user.js>
	- <https://github.com/yokoffing/Betterfox>
- Styles
	- <https://github.com/AveYo/fox>
	- <https://github.com/MrOtherGuy/firefox-csshacks>
	- <https://github.com/black7375/Firefox-UI-Fix>
	- <https://old.reddit.com/r/FirefoxCSS/comments/o1ccqe/a_different_way_of_displaying_the_container_color/>
	- <https://old.reddit.com/r/FirefoxCSS/comments/osles3/menu_icons/>
	- <https://old.reddit.com/r/FirefoxCSS/comments/obfa94/lepton_20_context_menu_icons_error_page/>
- Scripts
	- <http://kb.mozillazine.org/Profile_folder_-_Firefox>
	- <https://www.userchrome.org/what-is-userchrome-js.html>
	- <https://github.com/xiaoxiaoflood/firefox-scripts>
	- <https://github.com/MrOtherGuy/fx-autoconfig>
	- <https://greasyfork.org/en/scripts/3187-google-images-direct-link>
	- <https://greasyfork.org/en/scripts/10096-general-url-cleaner>
	- <https://greasyfork.org/en/scripts/431691-bypass-all-shortlinks>
	- <https://greasyfork.org/en/scripts/427254-preventpagevisibility>
	- <https://greasyfork.org/en/scripts/429635-always-on-focus>
